/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbvtkCreateImage_h_INCLUDED__
#define __bbvtkCreateImage_h_INCLUDED__
#include "bbvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"
#include <vector>
#include <string>

#include "vtkVersion.h"


#include "vtkImageData.h"

namespace bbvtk
{

class bbvtk_EXPORT CreateImage
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(CreateImage,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
	BBTK_DECLARE_INPUT(Dimensions,std::vector<int>);
	BBTK_DECLARE_INPUT(Spacing,std::vector<double>);
	BBTK_DECLARE_INPUT(OutputFormat,std::string);
	BBTK_DECLARE_INPUT(InitialValue,double);
	BBTK_DECLARE_OUTPUT(Out,vtkImageData *);
	BBTK_PROCESS(Process);
   void Process();
	
	vtkImageData* imageoutput;

	
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(CreateImage,bbtk::AtomicBlackBox);
	
	BBTK_NAME("CreateImage");
	BBTK_AUTHOR("Info-Dev");
	BBTK_DESCRIPTION("Create a new vtkImageData");
	BBTK_CATEGORY("Filter");
	
	BBTK_INPUT(CreateImage,Dimensions,"[SizeX SizeY SizeZ] of the image ([250 250 250] default)",std::vector<int>,"");
	BBTK_INPUT(CreateImage,Spacing,"[SpcX SpcY SpcZ] of the image ([1 1 1] default)",std::vector<double>,"");
	BBTK_INPUT(CreateImage,OutputFormat,"Image output format:  VTK_BIT, VTK_CHAR, VTK_SIGNED_CHAR, VTK_UNSIGNED_CHAR, VTK_SHORT, VTK_UNSIGNED_SHORT (default), VTK_INT, VTK_UNSIGNED_INT, VTK_LONG, VTK_UNSIGNED_LONG, VTK_FLOAT, VTK_DOUBLE",std::string,"");
	BBTK_INPUT(CreateImage,InitialValue,"Initial value inside the image (0 default)",double,"");

	BBTK_OUTPUT(CreateImage,Out,"Output vtkImageData",vtkImageData*,"");
	
BBTK_END_DESCRIBE_BLACK_BOX(CreateImage);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
}
// EO namespace bbvtk

#endif // __bbvtkCreateImage_h_INCLUDED__

